/**
 * Created by will on 10/1/15.
 */
var LocalStrategy = require('passport-local').Strategy;
var m3Hash = require('./hash');

module.exports = function(passport, models) {
    passport.serializeUser(function (user, done) {
        console.log("serializing user: " + user);
        done(null, user.username);
    });
    passport.deserializeUser(function (user, done) {
        console.log("deserializing user: " + user);

        models.User.findOne({
            where: {
                username: user
            }
        }).then(function (user) {
            console.log("deserializeD user: " + user);

            done(null, user);
        });
    });
    passport.use(new LocalStrategy(
        function (username, password, done) {
            console.log("using strat");
            var hash = new m3Hash();
            models.User.findOne({where: {username: username}})
                .then(function (user) {
                    console.log("user returned: " + user);
                    if (!user)
                        return done('Username not found. Please Try Again', false, null);
                    else if (!hash.isValidPassword(user, password))
                        return done('Incorrect Password. Please Try Again', null);
                    else {
                        return done(null, user);
                    }
                });
        }));
    passport.use('signup', new LocalStrategy({
            passReqToCallback: true
        },
        function (req, username, password, done) {
            var hash = new m3Hash();
            models.User.findOrCreate({
                where: {
                    username: username
                }, defaults: {
                    password: hash.createHash(password),
                    type: req.body.type,
                    displayName: req.body.displayName
                }
            }).spread(function (user, created) {
                if (created) {
                    return done(null, user);
                }
                else if (user) {
                    console.log("user");
                    return done('User Already Exists', null);

                } else {
                    console.log("failed");
                    return done('Failed to create user', null);
                }
            }).catch(function(err){
                console.log("failed");
                return done('Failed to create user: ' + err, null);
            });
        }
    ));
};

