/**
 * Created by TFG on 11/4/2019.
 * Modified by TFG on May 29, 2020.
 */

"use strict";

module.exports = function(sequelize, DataTypes) {
    var ActivityLog = sequelize.define('ActivityLog', {
            id: {
                type: DataTypes.INTEGER,
                field: 'id',
                primaryKey: true,
                autoIncrement: true
            },
            userId: {
                type: DataTypes.STRING,
                field: 'user_id'
            },
            nameTable: {
                type: DataTypes.STRING,
                field: 'name_table'
            },
            description: {
                type: DataTypes.STRING,
                field: 'description'
            },
            modified: {
                type: DataTypes.DATE,
                field: 'date_modification',
            }
        },
        {
            timestamps: false,
            tableName: 'tbl_activity_log',
            indexes: [
                // Create a unique index
                {
                    unique: true,
                    fields: ['modified']
                }
            ]
        }
    );
    return ActivityLog;
};
