/**
 * Created by TFG on 9/19/2019.
 * Model to handle the table tbl_sap_item_par_value
 * This table contains the min/max/qoh par values of some products.
 * The table is built via web console and/or bulk load.
 */
module.exports = function(sequelize, DataTypes) {
    var VendorSapParValue = sequelize.define('VendorSapParValue', {
            id: {
                type: DataTypes.INTEGER,
                field: 'id',
                primaryKey: true,
                autoIncrement: true
            },
            vendorMaterial: {
                type: DataTypes.STRING,
                field: 'vendor_material'
            },
            vendorId: {
                type: DataTypes.STRING,
                field: 'vendor_id'
            },
            clinicId: {
                type: DataTypes.STRING,
                field: 'clinic_id'
            },
            vendorDisplay: {
                type: DataTypes.STRING,
                field: 'vendor_display'
            },
            description: {
                type: DataTypes.STRING,
                field: 'material_description'
            },
            qohValue: {
                type: DataTypes.STRING,
                field: 'qoh_value'
            },
            minParValue: {
                type: DataTypes.STRING,
                field: 'min_par_value'
            },
            maxParValue: {
                type: DataTypes.STRING,
                field: 'max_par_value'
            }
        },
        {
            timestamps: false,
            tableName: 'tbl_sap_item_par_value',
            indexes: [
                // Create a unique index on device timestamp
                {
                    unique: true,
                    fields: ['vendorMaterial']
                }
            ]
        }
    );
    return VendorSapParValue;
};