/**
 * Created by John on 4/4/2017.
 */
var cluster = require('cluster');
var clusterManager = require('cluster-manager');
var port = process.env.PORT || 3000;
var numCPUs = require('os').cpus().length;
var env = process.env.NODE_ENV || "dev";
var path = require('path');

var childpath = path.join(__dirname, 'child.js');

if (cluster.isMaster) {

    var forks = (env == "dev") ? 2 : numCPUs;

    cluster.on('online', function(worker) {
        console.log('Worker ' + worker.process.pid + ' is online');
    });

    clusterManager({
        exec: childpath,
        workers: forks,
        notify: null
    });

}

process.on('uncaughtException', function (err) {
    var msg = (new Date).toUTCString() + ' uncaughtException:';
    console.error(msg, err.message);
    console.error(err.stack);
    process.exit(1);
});