SET NOCOUNT ON;
SET QUOTED_IDENTIFIER ON;
DECLARE @table_name as varchar(max)
DECLARE @table_cat as varchar(max)



DECLARE view_cursor CURSOR FOR 
SELECT Table_Catalog, Table_name FROM information_schema.tables where TABLE_TYPE = 'BASE TABLE' and table_name not like 'sys%' and table_name not like 'tbl_lu%' and table_name not like 'tbl_tmp%' and table_name not like '%_0630'

OPEN view_cursor

FETCH NEXT FROM view_cursor 
INTO @table_cat, @table_name

IF @@FETCH_STATUS =0
BEGIN
     select ''
     select '/*** SCHEMA'+@table_cat+' ***/ '

     select 'DROP SCHEMA IF EXISTS ' + QUOTENAME(@table_cat, '`') + ';'
     select ''
     select 'CREATE SCHEMA ' + QUOTENAME(@table_cat, '`') + ';'
     select ''
     select 'USE ' + QUOTENAME(@table_cat, '`') + ';'

END

WHILE @@FETCH_STATUS = 0
BEGIN

     select ''
     select '/*** TABLE '+@table_name+' ***/ '
     select 'DROP TABLE IF EXISTS ' + QUOTENAME(@table_name, '`') + ';'
     select ''
     select 'CREATE TABLE ' + QUOTENAME(@table_name, '`') + ' ('

-- column declaration 

     select  
     CHAR(9)
+ QUOTENAME(Column_Name, '`') + ' ' +
CASE WHEN DATA_TYPE = 'datetime2' then 'TIMESTAMP(3)' WHEN DATA_TYPE = 'ntext' then 'text' WHEN DATA_TYPE = 'bit' THEN 'TINYINT(1)' else DATA_TYPE end
+
replace(coalesce( '(' + cast(coalesce(replace(CHARACTER_MAXIMUM_LENGTH, -1, 2500), null) as varchar) + ')', ''), '(1073741823)', '')
+ ' ' +
case IS_NULLABLE WHEN 'NO' then 'NOT ' else '' end + 'NULL'
+ ' ' +
CASE WHEN @table_name in ('tbl_master_item', 'tbl_messages', 'tbl_clinic_profile', 'tbl_msg_recipients', 'tbl_inventory', 'tbl_vendor_list') AND DATA_TYPE = 'datetime2' and IS_NULLABLE <> 'NO' THEN 'DEFAULT NULL' 
WHEN @table_name in ('tbl_master_item', 'tbl_messages', 'tbl_clinic_profile', 'tbl_msg_recipients', 'tbl_inventory', 'tbl_vendor_list') AND DATA_TYPE = 'bit' THEN 'DEFAULT 0'  
WHEN @table_name like '%_history' AND Column_Name = 'date_archived' THEN 'DEFAULT CURRENT_TIMESTAMP(3)' ELSE '' end
+ ' ' +
case when COLUMNPROPERTY(OBJECT_ID(t.TABLE_CATALOG + '.' + t.TABLE_SCHEMA + '.' + t.TABLE_NAME), COLUMN_NAME, 'IsIdentity') = 1 then 'AUTO_INCREMENT' else '' end
--coalesce( 'DEFAULT ' + replace(replace(replace(COLUMN_DEFAULT, '(', ''), ')', ''), 'getdate', null), '')
+','
FROM information_schema.COLUMNS as c, INFORMATION_SCHEMA.TABLES as t 
where c.TABLE_NAME = t.TABLE_NAME and c.TABLE_CATALOG = t.TABLE_CATALOG and c.TABLE_SCHEMA = t.TABLE_SCHEMA
and c.TABLE_NAME = @table_name
-- PK
select  coalesce('PRIMARY KEY (' +STUFF((
SELECT distinct ', ' + QUOTENAME(Col.Column_Name,'`') from
    INFORMATION_SCHEMA.TABLE_CONSTRAINTS Tab inner join  
    INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE Col  on Col.Constraint_Name = Tab.Constraint_Name AND Col.Table_Name = Tab.Table_Name
WHERE        
    Constraint_Type = 'PRIMARY KEY '
    AND Col.Table_Name = @table_name
    FOR XML PATH(''), TYPE).value('.', 'NVARCHAR(MAX)') , 1, 1, '')+ ')', '') 

select ') Engine InnoDB;'

    FETCH NEXT FROM view_cursor 
    INTO @table_cat, @table_name
END 
CLOSE view_cursor;
DEALLOCATE view_cursor;